
float ballX = 0;
float ballY = 0;

float speedX = 0;
float speedY = 0;

float accX = 0;
float accY = 0;

float airFriction = 0.5;
float groundFriction = 0.9;
float gravity = 0.6;

float ballSize = 50;




void setup() {

  size(400, 400);
  smooth();
  background(255);

  ballX = width/2;
  ballY = height/2;
  speedX = 0;
  speedY = 0;
  accX = 1;
  accY = 1;
}

void draw() {

  //background(255);
  noStroke();
  fill(255, 40);
  rect(0, 0, width, height);
  updateBall();
  drawBall();
}


void updateBall() {

  // air friction:
  accX *= airFriction;
  accY *= airFriction;

  // gravity:
  accY += gravity;

  // accelerate:
  speedX += accX;
  speedY += accY;

  // move:
  ballX += speedX;
  ballY += speedY;

  // collide with borders:

  // right border:
  if (ballX+ballSize/2 >= width) {
    ballX = width - ballSize/2;
    speedX *= -1; // bounce back
    speedX *= groundFriction; // apply ground/wall friction
    speedY *= groundFriction;
  }
  
  // left border:
  if (ballX-ballSize/2 <= 0) {
    ballX = 0 + ballSize/2;
    speedX *= -1;
    speedX *= groundFriction;
    speedY *= groundFriction;
  }
  
  // bottom border:
  if (ballY+ballSize/2 >= height) {
    ballY = height - ballSize/2;
    speedY *= -1;
    speedX *= groundFriction;
    speedY *= groundFriction;
    
    // kick! once ball is resting:
    if (mag(speedX, speedY) < 0.6) {
      accX += 10-random(20);   
      accY += -10-random(30);
    }
  }
  
  // top border:
  if (ballY-ballSize/2 <= 0) {
    ballY = 0 + ballSize/2;
    speedY *= -1;
    speedX *= groundFriction;
    speedY *= groundFriction;
  }

}


void drawBall() {

  pushMatrix();
  fill(255, 0, 0);
  noStroke();
  ellipse(ballX, ballY, ballSize, ballSize);
  popMatrix();
}